<template>
  <div class="tselect" v-click-outside="focusOutDropDown">
    <div @click="focusSelect()" class="tselect-wrapper">
      <div v-if="multiple" class="tselect-wrapper__multiple">
        <span v-if="inner_value.length"> +{{ inner_value.length }} </span>
        <input
          type="text"
          ref="selectInput"
          v-model="searchValue"
          :placeholder="placeholder"
          @input="handleSearch()"
          :required="required_multiple"
          :disabled="disabled"
        />
      </div>

      <div v-if="single" class="tselect-wrapper__single">
        <input
          :required="required"
          :disabled="disabled"
          v-model="inner_value"
        />
        <label
          v-if="inner_value === ''"
          class="tselect-wrapper__single--placeholder"
        >
          {{ placeholder ? placeholder : `&nbsp;` }}
        </label>
        <label v-else v-html="inner_value"></label>
      </div>

      <i
        v-if="multiple && (searchValue || inner_value.length)"
        @click.stop="handleClear()"
        class="bx bx-x"
      ></i>

      <i
        v-if="disabled !== ''"
        :class="[
          isDropDown ? 'tselect-wrapper__arrow-rotate' : null,
          'bx',
          'bx-chevron-down',
        ]"
      ></i>
    </div>

    <transition name="fade">
      {{ inner_data }} kek
      <div v-if="isDropDown && disabled !== ''" class="tselect-dropdown">
        <div v-if="inner_data.length">
          <div
            v-if="multiple"
            v-for="response in inner_data_computed"
            class="tselect-dropdown__radio"
          >
            <input
              type="checkbox"
              :value="response.value"
              v-model="inner_value"
              :id="response.value"
            />
            <label :for="response.value">{{ response.label }}</label>
          </div>
          <div
            v-if="single"
            v-for="response in inner_data"
            @click="inner_value = response"
            class="tselect-dropdown__radio"
          >
            <span
              :style="{
                color: inner_value === response ? '#0c63e4' : '',
              }"
            >
              {{ response }}
            </span>
          </div>
        </div>
        <div v-else style="padding: 10px; text-align: center">
          <small> Ҳеҷ чиз ёфт нашуд </small>
        </div>
      </div>
    </transition>
  </div>
</template>

<script>
export default {
  props: {
    placeholder: {
      type: String,
      default: "",
    },
    single: {
      type: Boolean,
      default: false,
    },
    multiple: {
      type: Boolean,
      default: false,
    },
    value: {
      default: "",
    },
    data: {
      type: Array,
      default: Array,
    },
    required: {
      default: false,
    },
    disabled: {
      default: false,
    },
  },
  data() {
    return {
      searchValue: null,

      isDropDown: false,

      inner_value: this.value,
      inner_data: this.data,
      store_data: this.data,

      required_multiple: this.required,

      select_label: "",
    };
  },
  computed: {
    inner_data_computed() {
      if (this.multiple) {
        let list = this.inner_data.sort((a, b) => a.id - b.id);
        if (this.inner_value.length > 0) {
          list.forEach((data, index) => {
            this.inner_value.forEach((value) => {
              if (data.value === value) {
                list.splice(index, 1);
                list.unshift(data);
              }
            });
          });
        }
        return list;
      }
    },
  },
  watch: {
    inner_value() {
      setTimeout(() => {
        this.isDropDown = false;
      }, 100);
      if (
        this.inner_value.length > 0 &&
        this.required === "" &&
        this.multiple
      ) {
        this.required_multiple = false;
      } else {
        if (this.required === "") {
          this.required_multiple = true;
        } else {
          this.required_multiple = false;
        }
      }
      this.$emit("input", this.inner_value);
    },
    value() {
      this.inner_value = this.value;
    },
    data() {
      this.inner_data = this.data;
    },
  },
  methods: {
    handleSearch() {
      this.isDropDown = true;
      if (this.searchValue.length > 0) {
        this.inner_data = this.store_data.filter((value) => {
          return value.toLowerCase().includes(this.searchValue.toLowerCase());
        });
      } else {
        this.inner_data = this.store_data;
      }
    },
    focusSelect() {
      if (this.multiple) {
        this.$refs.selectInput.focus();
      }
      this.isDropDown = !this.isDropDown;
    },
    focusOutDropDown() {
      this.isDropDown = false;
    },
    handleClear() {
      this.isDropDown = false;
      this.searchValue = null;
      this.inner_data = this.store_data;
      this.inner_data.sort((a, b) => a - b);
      if (this.multiple) {
        this.inner_value = [];
      }
      if (this.single) {
        this.inner_value = "";
      }
      this.$emit("input", this.inner_value);
    },
  },
};
</script>

<style lang="scss" scoped>
.tselect {
  position: relative;
  transition: all ease 0.6s;

  &-wrapper {
    transition: all ease 0.6s;
    width: 100%;
    display: flex;
    align-items: center;
    // border-radius: 12px;
    position: relative;
    height: 100%;
    z-index: 5;
    background: #fff;
    border: 1px solid #e1e1e6;
    i {
      cursor: pointer;
      padding: 5px 10px;
      transition: all ease 0.3s;
    }
    span {
      height: auto;
      z-index: 6;
      background: #fff;
      // border-radius: 10px;
      padding: 0px 6px;
      margin: 2px auto;
      margin-right: 0;
      margin-left: 5px;
      border: 2px solid rgba(244, 247, 248, 1);
    }
  }
  &-wrapper__multiple {
    display: flex;
    align-items: center;
    width: 100%;

    input {
      color: #0c63e4;
      width: 100%;
      padding: 20px;
      background: #fff;
      // border-bottom-left-radius: 20px;
      // border-top-left-radius: 20px;
      transition: all ease 0.6s;
    }
  }
  &-wrapper__single {
    color: #0c63e4;
    display: block;
    width: 100%;
    padding: 20px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    input {
      padding-left: 0.01em;
      padding-right: 0.01em;
      opacity: 0;
      width: 0;
      height: 0;
      pointer-events: none;
    }
    label {
    }
  }
  &-wrapper__single--placeholder {
    color: rgb(117 117 118);
  }
  &-wrapper__arrow-rotate {
    transform: rotate(180deg);
  }

  &-dropdown {
    position: absolute;
    z-index: 99;
    overflow: auto;
    overflow-x: hidden;
    width: 100%;
    height: fit-content;
    max-height: 200px;
    box-shadow: 0 5px 15px rgba(204, 204, 204, 0.447);
    background: #fff;
    // border-radius: 12px;
    margin-top: 5px;
  }
  &-dropdown__radio {
    cursor: pointer;
    width: 100%;
    padding: 0 10px;
    transition: all ease 0.3s;
    display: flex;
    align-items: center;
    &:hover {
      color: #0c63e4;
      background-color: #d7d8da2a;
    }

    label {
      padding: 10px 0;
      width: 100%;
      display: block;
      cursor: pointer;
      margin-left: 10px;
    }

    span {
      padding: 10px 0;
      width: 100%;
      display: block;
      cursor: pointer;
      margin-left: 10px;
    }
  }
  .fade-enter-active {
    animation: fade 0.2s;
  }
  .fade-leave-active {
    animation: fade 0.2s reverse;
  }

  @keyframes fade {
    0% {
      opacity: 0;
      transform: translate3d(0, -5%, 0);
    }

    100% {
      opacity: 1;
      transform: translate3d(0, 0, 0);
    }
  }
}
</style>
